#include <stdio.h>
#include "os_menu.h"

_menu_type construct_menu(char **t_menu_items, int t_menu_size)
{
   _menu_type menu;
   menu.menu_items = t_menu_items;
   menu.menu_size  = t_menu_size;
   menu.current_selected_index = 0;
   
   return menu;
}

_log_type construct_log()
{
   _log_type log;
   log.log_size = 0;
   log.log_next_free = 0;
   return log;
}

void draw_menu(char* header, _menu_type* menu, int menu_screen_size)
{
   int offset = 0;
   int i = 0;
   
   printf("%s", header);
   fflush(stdout);
   
   if(menu->current_selected_index + 1 > menu_screen_size)
   {
      offset = menu->current_selected_index - menu_screen_size + 1;
   }
   
   for(i = 0; i < menu_screen_size; i++)
   {
      if((i+offset) < menu->menu_size)
      {
         if(menu->current_selected_index == (i+offset))
         {
            printf("[*]");
            fflush(stdout);
         }
         else
         {
            printf("[ ]");
            fflush(stdout);
         }
         printf(" %s", menu->menu_items[i+offset]);
#ifndef LINUX_TEST
   printf("\n");
#else
   printf("\r\n");
#endif
         fflush(stdout);
      }
      else
      {
#ifndef LINUX_TEST
   printf("\n");
#else
   printf("\r\n");
#endif
      }
   }
}

void draw_log(_log_type* log, int log_screen_size)
{
   int offset = 0;
   int i = 0;
   
   if(log->log_size > log_screen_size)
   {
      offset = log->log_size - log_screen_size;
   }
   
   for(i = 0; i < log_screen_size; i++)
   {
      if((i+offset) < log->log_size)
      {
         printf(" %s", log->log_items[i+offset]);
#ifndef LINUX_TEST
   printf("\n");
#else
   printf("\r\n");
#endif
         fflush(stdout);
      }
      else
      {
    	  #ifndef LINUX_TEST
    	     printf("\n");
    	  #else
    	     printf("\r\n");
    	  #endif
         fflush(stdout);
      }
   }
}

void draw_menu_and_log(char* header, char* footer, _menu_type* menu, int menu_screen_size, _log_type* log, int log_screen_size)
{
   
   draw_menu(header, menu, menu_screen_size);
  
   printf("================================================");
#ifndef LINUX_TEST
   printf("\n");
#else
   printf("\r\n");
#endif
   
   fflush(stdout);
   
   draw_log(log, log_screen_size);
   
   printf("================================================");
#ifndef LINUX_TEST
   printf("\n");
#else
   printf("\r\n");
#endif
   fflush(stdout);
   
   printf("%s",footer);
#ifndef LINUX_TEST
   printf("\n");
#else
   printf("\r\n");
#endif
   fflush(stdout);
}

void up_menu_item(_menu_type* menu)
{
   if(menu->current_selected_index > 0)
   {
      menu->current_selected_index = menu->current_selected_index - 1;
   }
}

void down_menu_item(_menu_type* menu)
{
   if(menu->current_selected_index < menu->menu_size - 1)
   {
      menu->current_selected_index = menu->current_selected_index + 1;
   }
   
}

void logmsg(_log_type* log, char* log_data)
{
   int i = 0;
   
   if(log->log_size < MAX_LOG_SIZE)
   {
      log->log_size = log->log_size + 1;
      log->log_items[log->log_size - 1] = log_data;
   }
   else  //shift log for now
   {
      for(i = 1; i < MAX_LOG_SIZE; i++)
      {
         log->log_items[i-1] = log->log_items[i];
      }
      log->log_items[MAX_LOG_SIZE - 1] = log_data;
   }
}

void dump_log_to_file(_log_type* log, char* filename)
{
   //does nothing atm.
}

char* selected_menu_text(_menu_type* menu)
{
   return menu->menu_items[menu->current_selected_index];
}
