#ifndef OS_MENU_H
#define OS_MENU_H

#define MAX_LOG_SIZE 10
#define MAX_MENU_SIZE 50

struct _menu_type{
   char **menu_items;
   int menu_size;
   int current_selected_index;
};

struct _log_type{
   char *log_items[MAX_LOG_SIZE];
   int log_size;
   int log_next_free;
   int max_log_size;
};

typedef struct _menu_type _menu_type;
typedef struct _log_type _log_type;

_menu_type construct_menu(char * t_menu_items[], int t_menu_size);

_log_type construct_log();

//Draw just the menu
void draw_menu(char* header, _menu_type* menu, int menu_screen_size);

//Draw just the log
void draw_log(_log_type* log, int log_screen_size);

//Draw Menu and the Log
void draw_menu_and_log(char* header, char* footer, _menu_type* menu, int menu_screen_size, _log_type* log, int log_screen_size);

void up_menu_item(_menu_type* menu);

void down_menu_item(_menu_type* menu);

void logmsg(_log_type* log, char* data);

void dump_log_to_file(_log_type* log, char* filename);

char* selected_menu_text(_menu_type* menu);
#endif //OS_MENU_H
